 
\PassOptionsToPackage{ELEC}{aaltologo}
\documentclass[logo=bluequo, normaltitle]{aaltoslides}
%\documentclass{aaltoslides} % DEFAULT
%\documentclass[first=purple,second=lgreen,logo=bquo,normaltitle,nofoot]{aaltoslides} % SOME OPTION EXAMPLES

\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{graphicx}
\usepackage{amssymb,amsmath}
\usepackage{url}
\usepackage{lastpage}
\usepackage{epstopdf}
%\usepackage[pdfpagemode=None,colorlinks=true,urlcolor=red, linkcolor=black,citecolor=black,pdfstartview=FitH]{hyperref}
\usepackage{mdframed}
\usepackage{caption}
\usepackage{apacite}
\usepackage{tikz}
\usetikzlibrary{positioning,shapes,shadows,arrows}
\tikzset{
  every overlay node/.style={
    %draw=black,fill=white,rounded corners,
    anchor=north west, inner sep=0pt,
  },
  thick/.style=      {line width=0.3mm},
}
\def\tikzoverlay{%
   \tikz[remember picture, overlay]\node[every overlay node]
}%

%%%%%%%%%%%%%%%The functions are collected here %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{./aaltobeamerfunctions.tex}
\graphicspath{ {./Pics/} }

%%%% To insert lecture date
%\newcommand{\lectdate}{19.11.2015}
\newcommand{\lectdate}{\today}
\newcommand{\slidetitle}{A-Core \\ Aalto RISC-V Organization and Objectives}
\newcommand{\mastersource}{git@bubba.ecdl.hut.fi:a-core/a-core\_documentation/a-core\_project\_description.git}

%%%%

\title{\slidetitle}

\institute[MNT]{Department of Micro and Nanosciences\\
Aalto University, School of Electrical Engineering }

\aaltofootertext{A-Core project description }{\lectdate}{\arabic{page}/\pageref{LastPage} }

\date{\lectdate}

\begin{document}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generates the titleframe
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\aaltotitleframe
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Contents
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\renewcommand{\sectionname}{Outline}
\section*{\sectionname} 
\begin{frame}[c]
    \frametitle{\sectionname}
    % \begin{minipage}[c][0.8\textheight]{0.6\textwidth}
    \tableofcontents
    % \end{minipage}
    % \hfill
    % \begin{minipage}[c][0.8\textheight]{0.38\textwidth}
    %         \includegraphics[width=\textwidth]{Pics/micrograph_labeled.pdf}  
    % \end{minipage}
    \tiny{The master source of this file: \mastersource}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \sectiontitle[Project objectives]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{\sectionname}
    \begin{itemize}
    \item A modular and easily expandable RISC-V core implementation.
    \item Project addresses the following areas of development: 
        \begin{itemize}
            \item Hardware description starting from  RV32I core
                implementation
            \item Programming interface
            \item Modular hardware extensions
            \item Hardware testing with RTL simulations
            \item Programming methodology, primarily for testing purposes
                (Assembly and C).
        \end{itemize}
    \item Due to the technology specific nature, and to retain modularity, this project does not address
        the implementation flows on ASIC or FPGA.
    \item Goal is to, from Chisel description, provide verified Verilog that
        can be then implemented on a chosen platform decided by user. 
    \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \sectiontitle[Project Organization]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Principles of project organization}
    \begin{itemize}
    \item Implementation is independent of verification and programming
    \item Programming is independent of verification and implementation
    \item Verification is performed in TheSyDeKick environment utilizes
        programs through A-core programming interface
        in RTL simulations.
    \item Verification may control implementation parameters
    \end{itemize}
    \resizebox{\textwidth}{!}{
    \begin{tikzpicture}[every node/.style={inner sep=0.5ex,outer sep=0},
            very thick/.style={line width=0.7mm}
        ]
        \tikzstyle{item}=[draw=black, rounded corners, 
            fill=secondarycolor!10, drop shadow,
            align=center, text=black, ellipse, minimum
            width=3cm,
        minimum height=2cm, line width=0.3mm] 
        \tikzstyle{box}=[draw=black, rounded corners, 
            fill=secondarycolor!10, drop shadow,
            align=center, text=black, rectangle, minimum
            width=3cm,
        minimum height=2cm] 

        \node [text width = 8cm, text height=2.8cm ] (mainbox) [box] {};
        \node [ below left = 0cm and 0cm of mainbox.north, anchor=north ]
        (maintext) {\textbf{A-Core\_TheSyDeKick}};
        \node [ below left = 1cm and 0cm of maintext.south, anchor=north ]
        (verification) {};
        \node [ below left = 0cm and 0.1cm of verification.west, anchor=east ]
        (software) [box] {\textbf{A-Core\_software}};
        \node [ below right = 0cm and 0.1cm of verification.east, anchor=west ]
        (implementation) [box] {\textbf{A-Core\_Chisel}};
        %\draw[>=latex,primarycolor,very thick,->] (sysadm.east) to [out=0,in=225]
        %(impl.south west);
        
    \end{tikzpicture}
}

    %\begin{center}
    % \includegraphics[width=0.6\textwidth]{Pics/A-core_functional.eps}  
    %\end{center}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Verification: A-Core\_TheSyDeKick}
    \begin{itemize}
    \item  A-Core project utilizes python based 'TheSyDeKick' verification
        environment to control RTL simulations
        (\url{https://github.com/TheSystemDevelopmentKit})
    \item Use of TheSyDeKick enables co-simulation and verification of mixed
        mode SoC's  controlled with a RISC-V core beyond the scope of this project.
    \item TheSyDeKick is used mainly for relatively low level RTL hardware verification. Designer is
        free to use any suitable verification environment for any other
        verification need.
    \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Implementation: A-Core\_Chisel}
    \begin{itemize}
        \item A-Core\_Chisel uses Chisel (Scala) project structure from Chisel-blocks
            (\url{https://github.com/Chisel-blocks/chisel-blocks-utils}). 
        \item See/try
            \url{https://github.com/Chisel-blocks/chisel-blocks-utils/blob/master/shell/init_module.sh}
        \item Principle: Independent design modules are handled with
            independent git projects that are \emph{nested} in Chisel-block
            hierarchy. 
        \item By doing so we achieve:
        \begin{itemize}
            \item Functional modularity
            \item Automated dependency tracking with git-based Scala project
                version control.
            \item Detailed version control.
            \item Cost: Hierarchical sub-module updates.
            \item Cost: Slow build times.
        \end{itemize}
    \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Current Implementation}
    \begin{itemize}
        \item Single cycle (non-pipelined) processor.
        \item Unprivileged (machine mode) execution environment.
        \item RV32I base ISA (formally verified with riscv-formal).
        \item M extension (mostly verified against Spike ISA simulator).
        \item Hardware extensions are optional and can be separately enabled.
    \end{itemize}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Memory Map}
    \begin{itemize}
        \item Memories and peripherals are mapped to a subset of the full 32-bit
            address space.
        \item Memory map can be easily customized with parameters in chisel.
        \item Memory map left unconstrained by the spec completely up for the
            implementor to decide. These can be changed if required.
        \item Current default values are summarized in table below:
    \end{itemize}
    \begin{table}[h]
        \begin{tabular}{lllll}
            \textbf{Purpose} & \textbf{Start Address} &
            \textbf{End Address} &  &  \\
            Program Memory   & 0x0001\_0000                       &
            0x0001\_EFFF                     &  &  \\
            Trap Handler     & 0x0001\_F000                       &
            0x0001\_FFFF                     &  &  \\
            RAM              & 0x2000\_0000                       &
            0x2000\_3FFF                     &  & 
        \end{tabular}
    \end{table}
\end{frame}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Git Repository Organization}
    \begin{itemize}
        \item The project repositories are organized into nested gitlab groups 
        \item \textbf{A-Core} -- top level group for the whole project
        \begin{itemize}
            \item \textbf{A-Core\_Chisel} -- chisel hardware implementation, \\
                each hardware module has its own git repository
            \item \textbf{A-Core\_TheSyDeKick} -- verification environment, \\
                each TheSyDeKick entity has its own git repository
            \item \textbf{A-Core\_software} -- A-Core software and related configuration
            \item \textbf{A-Core\_documentation} -- project documentation (like these slides)
        \end{itemize}
    \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{A-Core\_Chisel}
    \begin{itemize}
        \item The \textbf{A-Core\_Chisel} group contains repositories with
            the following purposes
        \begin{itemize}
            \item \textbf{a\_core\_base\_chisel} -- top level chisel hardware module
            \item \textbf{a\_core\_common} -- library containing definitions
                that need to be accessible for all modules (e.g. RV32I
                opcodes, custom data types)
            \item \textbf{chisel\_blocks\_util} -- helper scripts for generating new chisel modules
            \item All hardware modules should have their own repositories here to
                allow other hardware to use them as git submodules.

        \end{itemize}
    \end{itemize}
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[t]
\frametitle{Implementation: JTAG}
\begin{itemize}
	\item \textbf{JTAG implementation which can be utilized in multiple Aalto University's projects}
	\item \textbf{Old implementation of Berkley University's RocketChip's JTAG was used}
	\item \textbf{RocketChip code generates a JTAG TAP which ACore's JTAG module uses}
	\begin{itemize}
		\item Generated TAP creates homogeneous cell chains
		\item Missing (Update, Shift) chain types were added
	\end{itemize}
	\item \textbf{Generated JTAG TAP is configured with parameters when ACore's JTAG module is created}
	\item \textbf{TheSyDeKick is used to program ACore through JTAG}
	\begin{itemize}
		\item init.py for programmer initializing, controller.py for programmer main functions
		\item TheSyDeKick JTAG split in two:
		\begin{itemize}
			\item JTAG, holds general functions to drive JTAG TAP (reset, cycle, shift...)
			\item jtag\_programmer, holds ACore specific functions (tests)
		\end{itemize}
	\end{itemize}
\end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[t]
\frametitle{Implementation: F- \& Zicsr-extensions, 1}
\begin{itemize}
\item \textbf{F-extension requires control and status registers, Zicsr-extension}
\begin{itemize}
	\item 6 originally atomic instructions, which all have 2 modes according to contents
	of rd \& rs1
	\item swaps values between the Int register file and the Control status register or updates the register using 5 bit immediate
\end{itemize}
\item \textbf{32 floating point registers}
\begin{itemize}
	\item 32 bit wide, last one is F-extension CSR
	\item Int \& Float register files are separated but have routing to each other 
\end{itemize}
\item \textbf{26 instructions}
\begin{itemize}
	\item Use the same base format as the base ISA
	\item 2 for handling fcsr (rounding mode \& exception flags)
	\item 24 for Loading, storing, calculating, comparing, converting, moving and classifying single-precision floating point numbers
\end{itemize}
\end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[t]
\frametitle{F-extension plan}
\begin{center}
\includegraphics[scale=0.25]{F-extensionplan}
\end{center}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[t]
\frametitle{Implementation: F- \& Zicsr-extensions, 2}
\begin{itemize}
\item \textbf{Current progress:}
\begin{itemize}
\item ControlStatusBlock created to store CSRs (Zicsr-extension)
\item FloatRegFile created \& routing modified (F-extension)
\item F-extension commands added to DecoderBlock \& Control
\item SPFPBlock created \& apart from division all calculations implemented (F-extension)
\item High level structuring not yet done
\end{itemize}
\end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Documentation}
    \begin{itemize}
        \item Chisel modules are documented using scaladoc 
            {\tiny \url{https://docs.scala-lang.org/overviews/scaladoc/for-library-authors.html}}
        \item Scaladoc generates HTML documentation from
            specially formatted comments in Scala/Chisel source code
        \item Documentation for projects based Chisel-blocks template 
            can be generated with \texttt{./configure \&\&
        make doc}
        \item The generated documentation is placed at
            \texttt{./target/scala-2.12/api/} and can be viewed by
            opening \texttt{./target/scala-2.12/api/index.html} in a web browser
    \end{itemize}

\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[t]
    \frametitle{Contributors}
    \begin{itemize}
        \item Marko Kosunen -- marko.kosunen@aalto.fi
        \item Jussi Ryynänen -- jussi.ryynanen@aalto.fi
        \item Verneri Hirvonen -- verneri.hirvonen@aalto.fi
        \item Ilia Kempi -- ilia.kempi@aalto.fi
        \item Julius Helander -- julius.helander@aalto.fi
        \item Otto Simola -- otto.simola@aalto.fi
        \item Leo Uusimäki -- leo.uusimaki@aalto.fi
    \end{itemize}
\end{frame}

\end{document}


